D. Jellyfish and Mex Codeforces Round 901 (Div. 2)

Problem - D - Codeforces

题目大意:有一个n个数的数组a,数m初始为0,每次操作可以删除任意一个数,然后m加上那个数,求n次操作和m的最小值

1<=n<=5000;0<=ai<=1e9

思路:可以发现,如果我们要删除某个数,那么一定要把所有和这个数相等的数全部删去,这样才能使MEX变小,同时,所有大于MEX的数删去的花费都是0,所以我们每次操作的数的大小都是递减的,且只会操作MEX到0。

那么我们令dpi等于MEX等于i时的最小花费,我们从MEX到0枚举i,同时枚举该删哪个数,也就是从0到i-1遍历,当前最小花费就是不删这个数dpj,或者删这个数也就是dpi+当前MEX*(这个数数量-1)再加这个数,转移方程为dpj=min(dpj,dpi+i*(cntj-1)+j)

cpp 复制代码
//#include<__msvc_all_public_headers.hpp>
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 5e3 + 5;
ll n;
ll a[N];
ll cost[N];
ll cnt[N];
void init()
{
	for (int i = 0; i <= n; i++)
	{
		cost[i] = 1e18;
		cnt[i] = 0;
	}
}
ll gcd(ll a, ll b)
{
	return b ? gcd(b, a % b) : a;
}
ll lowbit(ll x)
{
	return x & (-x);
}
void solve()
{
	ll m;
	cin >> n;
	init();
	for (int i = 1; i <= n; i++)
	{
		cin >> a[i];
		if (a[i] <= n)
		{//MEX最大为n,大于n的都可以随便删
			cnt[a[i]]++;
		}
	}
	int mex = 0;
	while (cnt[mex])
	{//找当前的MEX
		mex++;
	}
	cost[mex] = 0;
	for (ll i = mex; i >= 0; i--)
	{
		for (ll j = 0; j < i; j++)
		{
			cost[j] = min(cost[j], cost[i] + i * (cnt[j] - 1) + j);
		}
	}
	cout << cost[0] << endl;
}
int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--)
	{
		solve();
	}
	return 0;
}
相关推荐
蜗牛一步步往上爬2 小时前
第十六章 C++语言在深度学习中的应用
开发语言·c++·深度学习
Navigator_Z5 小时前
LeetCode //C - 1317. Convert Integer to the Sum of Two No-Zero Integers
c语言·算法·leetcode
wo_jack6 小时前
C++ 入门笔记(十六):第16课 vector 模拟实现十问十答 —— 从三指针到迭代器失效
c++·后端·面试·stl·vector
D e re k ZH6 小时前
C++ 标准库算法全景指南
数据结构·c++·算法
冻柠檬飞冰走茶7 小时前
字母移动游戏题解:贪心求最长可保留连续子串(附 C 实现)
c语言·开发语言·数据结构·算法·动态规划
雪落漂泊7 小时前
C++算法 二分查找篇(上)
开发语言·c++·算法
不会算法的笨小孩9 小时前
异常的使用以及会出现的问题
开发语言·c++·c++11·异常
LabVIEW开发9 小时前
LabVIEW 连接板:28 个端子怎么排,优先级怎么定
java·算法·labview
严肃小白兔10 小时前
MATLAB 数值计算中的精度与误差问题:浮点运算、误差传播与数值稳定性
人工智能·算法·matlab